% TFG Calibracin de sensores acsticos - Pablo Gmez Magenti

clear, clc, %close all

% %-----------------------------------------------------------------------------------------------------------------------
% REPRESENTACIN CON AREA, FILL -> DESCOMENTAR LA ELIMINACIN DE NAN'S
% %-----------------------------------------------------------------------------------------------------------------------

color_azul_claro= [71 118 255]./255; 
color_azul_oscuro= [0 0 255]./255;

color_rojo_claro= [255 64 64]./255; 
color_rojo_oscuro= [255 0 0]./255; 

color_negro_claro= [32 32 32]./255; 
color_negro_oscuro= [0 0 0]./255;

%% Configuracin de las medidas

raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Comparacin directa\3 10.4.2016 + 4 1.6.2016';

carp_rec='TC4034_02 --}} SX60FR'; %(Amp. 600m, ampli+sonda) OK. 
% carp_rec='ITC-1032 --}}  SX60FR'; %(Amp. 400m, ampli+sonda) OK. 
% carp_rec='TC4034_01 --}} SX60FR'; %(Amp. 400m, ampli+sonda) OK. 

% carp_rec='TC4034_02 --}}  ITC-1032'; %(Amp. 400m, ampli+sonda) OK. 
% carp_rec='SX60FR --}}  ITC-1032'; %(Amp. 400m, ampli+sonda) OK. 
% carp_rec='TC4034_01 --}} ITC-1032'; %(Amp. 400m, ampli+sonda) OK. 

% carp_rec='SX60FR  --}}  TC4034_02'; %(Amp. 400m, ampli+sonda) OK. 
% carp_rec='ITC-1032  --}} TC4034_02'; %(Amp. 600m, ampli+sonda) OK. 

% carp_rec='ITC-1032 --}} TC4034_01'; %(Amp. 400m, ampli+sonda) OK. 
% carp_rec='SX60FR --}} TC4034_01'; %(Amp. 400m, ampli+sonda) OK. 

fs=2*1e6;           % frecuencia de muestro en emisin y recepcin [Hz]
d_ini=0;            % distancia real de la carpeta 0cm [m]
t_ini_env=0;        % tiempo inicial de espera, en su caso [s]
prom=5;             % nmero de promedios de cada seal [-]
ciclos=5;           % ciclos a analizar de cada seal [-]
encabezado=31;      % encabezado que de las seales grabadas ('31' en medidas en plataforma PXI)

% Seales enviadas:
[f_env,Vp_env_t,Vp_env_f,Vp_env_c,d_env]=Vp_senos(raiz,carp_rec,fs,d_ini,'inicio',t_ini_env,100,prom,ciclos,1,encabezado);

% Seales recibidas:
[f_rec,Vp_rec_t,Vp_rec_f,Vp_rec_c,d_rec]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,2,encabezado);

% Compatibilidad de medidas:
if f_env==f_rec;
    f=f_env;
else
    disp('Incompatibilidad entre medidas');
end;
d=d_rec;
P_ref=1*1e-6;       % presin de referencia [Pa]

%% Dibuja las amplitudes:
%-----------------------------------------------------------------------------------------------------------------------
%EMITTED SIGNAL utilizando la funcin ERRORBAR:
h=figure('Position',[5 45 1360 635]); hold on
    errorbar(f/1e3,mean(Vp_env_t),std(Vp_env_t),'o:b','LineWidth',1,'MarkerFaceColor','b');
    errorbar(f/1e3,mean(Vp_env_f),std(Vp_env_f),'o:r','LineWidth',1,'MarkerFaceColor','r');
    errorbar(f/1e3,mean(Vp_env_c),std(Vp_env_c),'o:k','LineWidth',1,'MarkerFaceColor','k');
    xlabel('Frequency [kHz]','FontSize',15); ylabel('Amplitude [V]','FontSize',15);
    title('Emitted voltage','FontSize',15); box('on');
    legend('Emitted signal (time)','Emitted signal (freq)','Emitted signal (corr)','Location','NorthEastOutside');
    set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([Vp_env_t Vp_env_f Vp_env_c])) max(max([Vp_env_t Vp_env_f Vp_env_c]))])
    saveas(h,[raiz,'\','Vp_env (utilizando la funcin ERRORBAR) ',carp_rec], 'fig');

%RECEIVED SIGNAL utilizando la funcin ERRORBAR:   
h=figure('Position',[5 45 1360 635]); hold on
    errorbar(f/1e3,mean(Vp_rec_t)*1e3,std(Vp_rec_t)*1e3,'o:b','LineWidth',1,'MarkerFaceColor','b');
    errorbar(f/1e3,mean(Vp_rec_f)*1e3,std(Vp_rec_f)*1e3,'o:r','LineWidth',1,'MarkerFaceColor','r');
    errorbar(f/1e3,mean(Vp_rec_c)*1e3,std(Vp_rec_c)*1e3,'o:k','LineWidth',1,'MarkerFaceColor','k');
    xlabel('Frequency [kHz]','FontSize',15); ylabel('Amplitude [mV]','FontSize',15);
    title('Received voltage','FontSize',15); box('on');
    legend('Received signal (time)','Received signal (freq)','Received signal (corr)','Noise (time)','Noise (freq)','Location','NorthEastOutside');
    set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 0 max(max([Vp_rec_t Vp_rec_f Vp_rec_c]))*1e3])    
    saveas(h,[raiz,'\','Vp_rec (utilizando la funcin ERRORBAR) ',carp_rec], 'fig');

%EMITTED SIGNAL utilizando la funcin FILL:
h=figure('Position',[5 45 1360 635]); hold on;
    fill([f/1e3 fliplr(f/1e3)],[mean(Vp_env_t)+std(Vp_env_t) fliplr(mean(Vp_env_t)-std(Vp_env_t))],color_azul_claro,...
        'EdgeColor',color_azul_claro);          
    plot(f/1e3, mean(Vp_env_t),'LineWidth',3,'Color',color_azul_oscuro)
    fill([f/1e3 fliplr(f/1e3)],[mean(Vp_env_f)+std(Vp_env_f) fliplr(mean(Vp_env_f)-std(Vp_env_f))],color_rojo_claro,...
        'EdgeColor',color_rojo_claro);
    plot(f/1e3, mean(Vp_env_f),'LineWidth',3,'Color',color_rojo_oscuro)
    fill([f/1e3 fliplr(f/1e3)],[mean(Vp_env_c)+std(Vp_env_c) fliplr(mean(Vp_env_c)-std(Vp_env_c))],color_negro_claro,...
        'EdgeColor',color_negro_claro);
    plot(f/1e3, mean(Vp_env_c),'LineWidth',3,'Color',color_negro_oscuro)           

    xlabel('Frequency [kHz]','FontSize',15); ylabel('Amplitude [V]','FontSize',15);
    title('Emitted voltage','FontSize',15); box('on');
    legend('Emitted signal (time std)','Emitted signal (time mean)','Emitted signal (freq std)','Emitted signal (freq mean)',...
        'Emitted signal (corr std)','Emitted signal (corr mean)','Location','NorthEastOutside');
    set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([Vp_env_t Vp_env_f Vp_env_c])) max(max([Vp_env_t Vp_env_f Vp_env_c]))])
    saveas(h,[raiz,'\','Vp_env (utilizando la funcin FILL) ',carp_rec], 'fig');

%RECEIVED SIGNAL utilizando la funcin FILL:
h=figure('Position',[5 45 1360 635]); hold on     
    fill([f/1e3 fliplr(f/1e3)],[mean(Vp_rec_t)*1e3+std(Vp_rec_t)*1e3 fliplr(mean(Vp_rec_t)*1e3-std(Vp_rec_t)*1e3)],color_azul_claro,...
        'EdgeColor',color_azul_claro);          
    plot(f/1e3, mean(Vp_rec_t)*1e3,'LineWidth',3,'Color',color_azul_oscuro)
    fill([f/1e3 fliplr(f/1e3)],[mean(Vp_rec_f)*1e3+std(Vp_rec_f)*1e3 fliplr(mean(Vp_rec_f)*1e3-std(Vp_rec_f)*1e3)],color_rojo_claro,...
        'EdgeColor',color_rojo_claro);
    plot(f/1e3, mean(Vp_rec_f)*1e3,'LineWidth',3,'Color',color_rojo_oscuro)
    fill([f/1e3 fliplr(f/1e3)],[mean(Vp_rec_c)*1e3+std(Vp_rec_c)*1e3 fliplr(mean(Vp_rec_c)*1e3-std(Vp_rec_c)*1e3)],color_negro_claro,...
        'EdgeColor',color_negro_claro);
    plot(f/1e3, mean(Vp_rec_c)*1e3,'LineWidth',3,'Color',color_negro_oscuro)           

    xlabel('Frequency [kHz]','FontSize',15); ylabel('Amplitude [mV]','FontSize',15);
    title('Received voltage','FontSize',15); box('on');
    legend('Received signal (time std)','Received signal (time mean)','Received signal (freq std)','Received signal (freq mean)',...
        'Received signal (corr std)','Received signal (corr mean)','Location','NorthEastOutside');
    set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 0 max(max([Vp_rec_t Vp_rec_f Vp_rec_c]))*1e3])    
    saveas(h,[raiz,'\','Vp_rec (utilizando la funcin FILL) ',carp_rec], 'fig');

%% 
TIPO = menu('Qu deseas obtener?',{'TVR','RVR'}); 
switch TIPO  
% %-----------------------------------------------------------------------------------------------------------------------
% %------------------------------------------------CASE1------------------------------------------------------------------
% %-----------------------------------------------------------------------------------------------------------------------
    
    case 1; % Obtencin de la sensibilidad de emisin (TVR)
        for j=1:length(f);
            for i=1:prom;
                % Sensibilidad del transductor receptor (dB @ V/uPa)
                  S_rec(j)= RVR_SX60FR(f(j));
%                 S_rec(j)= RVR_ITC_1032(f(j));
%                 S_rec(j)= RVR_TC4034(f(j));                               
                % Coeficiente de absorcin del medio:
                % alfa(j)=abs_agua(f(j));
                % Presiones de pico de las seales recibidas a d[m] y a 1[m]:
                Pp_d_t(i,j)=Vp_rec_t(i,j)*1e6/10^(S_rec(j)/20);
                Pp_d_f(i,j)=Vp_rec_f(i,j)*1e6/10^(S_rec(j)/20);
                Pp_d_c(i,j)=Vp_rec_c(i,j)*1e6/10^(S_rec(j)/20);
                Pp_1m_t(i,j)=Pp_d_t(i,j)*d;%*exp(-alfa(j)*(1-d));
                Pp_1m_f(i,j)=Pp_d_f(i,j)*d;%*exp(-alfa(j)*(1-d));
                Pp_1m_c(i,j)=Pp_d_c(i,j)*d;%*exp(-alfa(j)*(1-d));
                % Voltajes de pico de las seales enviadas:
                Vp_t(i,j)=Vp_env_t(i,j);
                Vp_f(i,j)=Vp_env_f(i,j);
                Vp_c(i,j)=Vp_env_c(i,j);
                % Sensibilidad del piezoelctrico emisor @ 1[m]:
                TVR_1m_t(i,j)=20*log10(Pp_1m_t(i,j)/Vp_t(i,j)*1e-6);
                TVR_1m_f(i,j)=20*log10(Pp_1m_f(i,j)/Vp_f(i,j)*1e-6);
                TVR_1m_c(i,j)=20*log10(Pp_1m_c(i,j)/Vp_c(i,j)*1e-6);
                    % Para evitar el error que da al trabajar con AREA y
                    % FILL luego. Conversin de todos los NaN's en 0's.
                    TVR_1m_t(isnan(TVR_1m_t))=0;
                    TVR_1m_f(isnan(TVR_1m_f))=0;
                    TVR_1m_c(isnan(TVR_1m_c))=0;  
                % Nivel de presin receptor @ 1[m]:
                SPL_1m_t(i,j)=20*log10(Vp_t(i,j)*10^(TVR_1m_t(i,j)/20)/P_ref*1e-6);
                SPL_1m_f(i,j)=20*log10(Vp_f(i,j)*10^(TVR_1m_f(i,j)/20)/P_ref*1e-6);
                SPL_1m_c(i,j)=20*log10(Vp_c(i,j)*10^(TVR_1m_c(i,j)/20)/P_ref*1e-6);
                    % Para evitar el error que da al trabajar con AREA y
                    % FILL luego. Conversin de todos los NaN's en 0's.
                    SPL_1m_t(isnan(SPL_1m_t))=0;
                    SPL_1m_f(isnan(SPL_1m_f))=0;
                    SPL_1m_c(isnan(SPL_1m_c))=0;                                    
            end
        end
%-----------------------------------------------------------------------------------------------------------------------
% TVR utilizando la funcin PLOT nicamente:
         h=figure('Position',[5 45 1360 635]); hold on
            plot(f/1e3,mean(TVR_1m_t),'LineWidth',3,'Color','b');
            plot(f/1e3,mean(TVR_1m_f),'LineWidth',3,'Color','r');
            plot(f/1e3,mean(TVR_1m_c),'LineWidth',3,'Color','k');
            xlabel('Frequency [kHz]','FontSize',15); ylabel('TVR [dB re uPa/V @ 1m]','FontSize',15);
            title(['Transmitting Voltage Response ',carp_rec],'FontSize',15); box('on');
            legend('TVR (time)','TVR (freq)','TVR (corr)','Location','NorthEastOutside');
            set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([TVR_1m_t TVR_1m_f])) max(max([TVR_1m_t TVR_1m_f]))])
            saveas(h, [raiz,'\','TVR (utilizando la funcin PLOT) ',carp_rec], 'fig');

% TVR utilizando la funcin ERRORBAR:
        h=figure('Position',[5 45 1360 635]); hold on
            errorbar(f/1e3,mean(TVR_1m_t),std(TVR_1m_t),'o:b','LineWidth',1,'MarkerFaceColor','b');
            errorbar(f/1e3,mean(TVR_1m_f),std(TVR_1m_f),'o:r','LineWidth',1,'MarkerFaceColor','r');
            errorbar(f/1e3,mean(TVR_1m_c),std(TVR_1m_c),'o:k','LineWidth',1,'MarkerFaceColor','k');
            xlabel('Frequency [kHz]','FontSize',15); ylabel('TVR [dB re uPa/V @ 1m]','FontSize',15);
            title(['Transmitting Voltage Response ',carp_rec],'FontSize',15); box('on');
            legend('TVR (time)','TVR (freq)','TVR (corr)','Location','NorthEastOutside');
            set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([TVR_1m_t TVR_1m_f])) max(max([TVR_1m_t TVR_1m_f]))])
            saveas(h, [raiz,'\','TVR (utilizando la funcin ERRORBAR) ',carp_rec], 'fig');        

% TVR utilizando la funcin FILL:
        h=figure('Position',[5 45 1360 635]); hold on       
            fill([f/1e3 fliplr(f/1e3)],[mean(TVR_1m_t)+std(TVR_1m_t) fliplr(mean(TVR_1m_t)-std(TVR_1m_t))],color_azul_claro,...
                'EdgeColor',color_azul_claro);          
            plot(f/1e3, mean(TVR_1m_t),'LineWidth',3,'Color',color_azul_oscuro)            
            fill([f/1e3 fliplr(f/1e3)],[mean(TVR_1m_f)+std(TVR_1m_f) fliplr(mean(TVR_1m_f)-std(TVR_1m_f))],color_rojo_claro,...
                'EdgeColor',color_rojo_claro);
            plot(f/1e3, mean(TVR_1m_f),'LineWidth',3,'Color',color_rojo_oscuro)           
            fill([f/1e3 fliplr(f/1e3)],[mean(TVR_1m_c)+std(TVR_1m_c) fliplr(mean(TVR_1m_c)-std(TVR_1m_c))],color_negro_claro,...
                'EdgeColor',color_negro_claro);
            plot(f/1e3, mean(TVR_1m_c),'LineWidth',3,'Color',color_negro_oscuro)                
            
            xlabel('Frequency [kHz]','FontSize',15); ylabel('TVR [dB re uPa/V @ 1m]','FontSize',15);
            title(['Transmitting Voltage Response ',carp_rec],'FontSize',15); box('on');
            legend('TVR (time std)','TVR (time mean)','TVR (freq std)','TVR (freq mean)',...
                'TVR (corr std)','TVR (corr mean)','Location','NorthEastOutside');
            set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([TVR_1m_t TVR_1m_f])) max(max([TVR_1m_t TVR_1m_f]))])
            saveas(h, [raiz,'\','TVR (utilizando la funcin FILL) ',carp_rec], 'fig');            
%-----------------------------------------------------------------------------------------------------------------------
% SPL utilizando la funcin PLOT nicamente:
        h=figure('Position',[5 45 1360 635]); hold on
            plot(f/1e3,mean(SPL_1m_t),'LineWidth',3,'Color','b');
            plot(f/1e3,mean(SPL_1m_f),'LineWidth',3,'Color','r');
            plot(f/1e3,mean(SPL_1m_c),'LineWidth',3,'Color','k');
            xlabel('Frequency [kHz]','FontSize',15); ylabel(['SPL [dB re 1uPa @ 1m @',num2str(1),'V]'],'FontSize',15);
            title(['Pressure Level ',carp_rec],'FontSize',15); box('on');
            legend('SPL (time)','SPL (freq)','SPL (corr)','Location','NorthEastOutside');
            set(gca,'FontSize',15); 
            axis([f(1)/1e3 f(end)/1e3 min(min([SPL_1m_t SPL_1m_f])) max(max([SPL_1m_t SPL_1m_f]))])
            saveas(h, [raiz,'\','SPL (utilizando la funcin PLOT) ',carp_rec], 'fig');
            
% SPL utilizando la funcin ERRORBAR:            
         h=figure('Position',[5 45 1360 635]); hold on
            errorbar(f/1e3,mean(SPL_1m_t),std(SPL_1m_t),'o:b','LineWidth',1,'MarkerFaceColor','b');
            errorbar(f/1e3,mean(SPL_1m_f),std(SPL_1m_f),'o:r','LineWidth',1,'MarkerFaceColor','r');
            errorbar(f/1e3,mean(SPL_1m_c),std(SPL_1m_c),'o:k','LineWidth',1,'MarkerFaceColor','k');
            xlabel('Frequency [kHz]','FontSize',15); ylabel(['SPL [dB re 1uPa @ 1m @',num2str(1),'V]'],'FontSize',15);
            title(['Pressure Level ',carp_rec],'FontSize',15); box('on');
            legend('SPL (time)','SPL (freq)','SPL (corr)','Location','NorthEastOutside');
            set(gca,'FontSize',15); 
            axis([f(1)/1e3 f(end)/1e3 min(min([SPL_1m_t SPL_1m_f])) max(max([SPL_1m_t SPL_1m_f]))])
            saveas(h, [raiz,'\','SPL (utilizando la funcin ERRORBAR) ',carp_rec], 'fig');           
            
% SPL utilizando la funcin FILL:
        h=figure('Position',[5 45 1360 635]); hold on           
            fill([f/1e3 fliplr(f/1e3)],[mean(SPL_1m_t)+std(SPL_1m_t) fliplr(mean(SPL_1m_t)-std(SPL_1m_t))],color_azul_claro,...
                'EdgeColor',color_azul_claro);          
            plot(f/1e3, mean(SPL_1m_t),'LineWidth',3,'Color',color_azul_oscuro)            
            fill([f/1e3 fliplr(f/1e3)],[mean(SPL_1m_f)+std(SPL_1m_f) fliplr(mean(SPL_1m_f)-std(SPL_1m_f))],color_rojo_claro,...
                'EdgeColor',color_rojo_claro);
            plot(f/1e3, mean(SPL_1m_f),'LineWidth',3,'Color',color_rojo_oscuro)           
            fill([f/1e3 fliplr(f/1e3)],[mean(SPL_1m_c)+std(SPL_1m_c) fliplr(mean(SPL_1m_c)-std(SPL_1m_c))],color_negro_claro,...
                'EdgeColor',color_negro_claro);
            plot(f/1e3, mean(SPL_1m_c),'LineWidth',3,'Color',color_negro_oscuro) 
        
            xlabel('Frequency [kHz]','FontSize',15); ylabel(['SPL [dB re 1uPa @ 1m @',num2str(1),'V]'],'FontSize',15);
            title(['Pressure Level ',carp_rec],'FontSize',15); box('on');
            %legend('SPL (time)','SPL (freq)','SPL (corr)');
            legend('SPL (time std)','SPL (time mean)','SPL (freq std)','SPL (freq mean)',...
                'SPL (corr std)','SPL (corr mean)','Location','NorthEastOutside');
            set(gca,'FontSize',15); 
            axis([f(1)/1e3 f(end)/1e3 min(min([SPL_1m_t SPL_1m_f])) max(max([SPL_1m_t SPL_1m_f]))])
            saveas(h, [raiz,'\','SPL (utilizando la funcin FILL) ',carp_rec], 'fig');             
                          
% %-----------------------------------------------------------------------------------------------------------------------
% %--------------------------------------------------CASE2----------------------------------------------------------------
% %-----------------------------------------------------------------------------------------------------------------------
    case 2; % Obtencin de la sensibilidad de recepcin (RVR)
        for j=1:length(f);
            for i=1:prom;
                % Sensibilidad del transductor emisor:
%                 S_env(j)=TVR_SX60FR(f(j));
%                 S_env(j)=TVR_ITC_1032(f(j));
%                 S_env(j)=TVR_TC4034(f(j));
                % Coeficiente de absorcin del medio:
                % alfa(j)=abs_agua(f(j));
                % Presiones de pico de las seales enviadas a 1[m] y a d[m]:
                Pp_1m_t(i,j)=10^(S_env(j)/20)*Vp_env_t(i,j)*1e-6;
                Pp_1m_f(i,j)=10^(S_env(j)/20)*Vp_env_f(i,j)*1e-6;
                Pp_1m_c(i,j)=10^(S_env(j)/20)*Vp_env_c(i,j)*1e-6;
                Pp_d_t(i,j)=Pp_1m_t(i,j)/d;%*exp(-alfa(j)*(d-1));
                Pp_d_f(i,j)=Pp_1m_f(i,j)/d;%*exp(-alfa(j)*(d-1));
                Pp_d_c(i,j)=Pp_1m_c(i,j)/d;%*exp(-alfa(j)*(d-1));
                % Voltajes de pico de las seales recibidas a d[m]:
                Vp_d_t(i,j)=Vp_rec_t(i,j);
                Vp_d_f(i,j)=Vp_rec_f(i,j);
                Vp_d_c(i,j)=Vp_rec_c(i,j);
                % Sensibilidad del piezoelctrico receptor:
                RVR_t(i,j)=20*log10(Vp_d_t(i,j)/Pp_d_t(i,j)*1e-6);
                RVR_f(i,j)=20*log10(Vp_d_f(i,j)/Pp_d_f(i,j)*1e-6);
                RVR_c(i,j)=20*log10(Vp_d_c(i,j)/Pp_d_c(i,j)*1e-6);
                    % Para evitar el error que da al trabajar con AREA y
                    % FILL luego. Conversin de todos los NaN's en 0's.
                    RVR_t(isnan(RVR_t))=0;
                    RVR_f(isnan(RVR_f))=0;
                    RVR_c(isnan(RVR_c))=0;  
            end
        end

%-----------------------------------------------------------------------------------------------------------------------
% RVR utilizando la funcin ERRORBAR:        
         h=figure('Position',[5 45 1360 635]); hold on
            errorbar(f/1e3,mean(RVR_t),std(RVR_t),'o:b','LineWidth',1,'MarkerFaceColor','b');
            errorbar(f/1e3,mean(RVR_f),std(RVR_f),'o:r','LineWidth',1,'MarkerFaceColor','r');
            errorbar(f/1e3,mean(RVR_c),std(RVR_c),'o:k','LineWidth',1,'MarkerFaceColor','k');
            xlabel('Frequency [kHz]','FontSize',15); ylabel('RVR [dB re V/uPa]','FontSize',15);
            title(['Received Voltage Response ',carp_rec],'FontSize',15); box('on');
            legend('RVR (time)','RVR (freq)','RVR (corr)','Location','NorthEastOutside');
            set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([RVR_t RVR_f])) max(max([RVR_t RVR_f]))])             
            saveas(h,[raiz,'\','RVR (utilizando la funcin ERRORBAR) ',carp_rec],'fig');
            
% RVR utilizando la funcin PLOT nicamente:
         h=figure('Position',[5 45 1360 635]); hold on
            plot(f/1e3,mean(RVR_t),'LineWidth',3,'Color','b');
            plot(f/1e3,mean(RVR_f),'LineWidth',3,'Color','r');
            plot(f/1e3,mean(RVR_c),'LineWidth',3,'Color','k');
            xlabel('Frequency [kHz]','FontSize',15); ylabel('RVR [dB re V/uPa]','FontSize',15);
            title(['Received Voltage Response ',carp_rec],'FontSize',15); box('on');
            legend('RVR (time)','RVR (freq)','RVR (corr)','Location','NorthEastOutside');
            set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([RVR_t RVR_f])) max(max([RVR_t RVR_f]))])             
            saveas(h,[raiz,'\','RVR (utilizando la funcin PLOT) ',carp_rec],'fig');

% RVR utilizando la funcin FILL:
        h=figure('Position',[5 45 1360 635]); hold on                     
            fill([f/1e3 fliplr(f/1e3)],[mean(RVR_t)+std(RVR_t) fliplr(mean(RVR_t)-std(RVR_t))],color_azul_claro,...
                'EdgeColor',color_azul_claro);          
            plot(f/1e3, mean(RVR_t),'LineWidth',3,'Color',color_azul_oscuro)            
            fill([f/1e3 fliplr(f/1e3)],[mean(RVR_f)+std(RVR_f) fliplr(mean(RVR_f)-std(RVR_f))],color_rojo_claro,...
                'EdgeColor',color_rojo_claro);
            plot(f/1e3, mean(RVR_f),'LineWidth',3,'Color',color_rojo_oscuro)           
            fill([f/1e3 fliplr(f/1e3)],[mean(RVR_c)+std(RVR_c) fliplr(mean(RVR_c)-std(RVR_c))],color_negro_claro,...
                'EdgeColor',color_negro_claro);
            plot(f/1e3, mean(RVR_c),'LineWidth',3,'Color',color_negro_oscuro)                
            
            xlabel('Frequency [kHz]','FontSize',15); ylabel('RVR [dB re V/uPa]','FontSize',15);
            title(['Received Voltage Response ',carp_rec],'FontSize',15); box('on');
            legend('RVR (time std)','RVR (time mean)','RVR (freq std)','RVR (freq mean)',...
                'RVR (corr std)','RVR (corr mean)','Location','NorthEastOutside');
            set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([RVR_t RVR_f])) max(max([RVR_t RVR_f]))])
            saveas(h,[raiz,'\','RVR (utilizando la funcin FILL) ',carp_rec],'fig');  
%-----------------------------------------------------------------------------------------------------------------------                     
end