% TFG Calibracin de sensores acsticos - Pablo Gmez Magenti

clear, clc, close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Vtr -> Voltaje emitiendo con t y recibiendo con r 
% Vth -> Voltaje emitiendo con t y recibiendo con h 
% Vrh -> Voltaje emitiendo con r y recibiendo con h 
% Vrt -> Voltaje emitiendo con r y recibiendo con t 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 

% TANQUE LABORATORIO:
% raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad4 15.6.2016 (Sensibilidad del SX30FR)';
% nombre_hid_sensibilidad='SX30FR'; 
% OK.

% raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad4 15.6.2016 (Sensibilidad del SX60FR)';
% nombre_hid_sensibilidad='SX60FR'; 
% OK.

% raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad4 15.6.2016 (Sensibilidad del TC4034_01)';
% nombre_hid_sensibilidad='TC4034_01'; 
% OK.

%%

% PISCINA PUERTO:
raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad5 30.6.2016 (Sensibilidad SX60FR)(PUERTO)(T. EQUILTERO)';
nombre_hid_sensibilidad='SX60FR (T. EQUILTERO)(PUERTO)'; 
% OK.

%%

fs=2*1e6;           % frecuencia de muestro en emisin y recepcin [Hz]
d_ini=0;            % distancia real de la carpeta 0cm [m]
t_ini_env=0;        % tiempo inicial de espera, en su caso [s]
prom=5;             % nmero de promedios de cada seal [-]
ciclos=5;           % ciclos a analizar de cada seal [-]
encabezado=31;      % encabezado que de las seales grabadas ('31' en medidas en plataforma PXI)

carp_rec='Conf1';
[ftr,Vtr_t,Vtr_f,Vtr_c,dtr]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,1,encabezado);
[fth,Vth_t,Vth_f,Vth_c,dth]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,2,encabezado);

carp_rec='Conf2';
[fR,VR_t,VR_f,VR_c,dR]=Vp_senos_resta(raiz,carp_rec,fs,d_ini,'inicio',t_ini_env,100,prom,ciclos,1,2,encabezado);

carp_rec='Conf3';
[frh,Vrh_t,Vrh_f,Vrh_c,drh]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,1,encabezado);
[frt,Vrt_t,Vrt_f,Vrt_c,drt]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,2,encabezado);

%% Clculo de la sensibilidad y representacin:

if and(ftr==fR,fR==frh)==1;
    f=[ftr;ftr;ftr;ftr;ftr];
else 
    disp('Incompatibilidad entre medidas');
end;

d=(dtr+dth+drh+drt)/6;
disp(d)
ro=1500;

P_ref=1*1e-6;               % Presin de referencia [Pa]
ValorResistencia=1000;      % Marrn-Negro-Rojo-Oro
     
IR_t=VR_t/ValorResistencia;
IR_f=VR_f/ValorResistencia;
IR_c=VR_c/ValorResistencia;

SH_t=sqrt((2*d/ro./f).*(Vth_t.*Vrh_t)./(Vtr_t.*IR_t));
SH_f=sqrt((2*d/ro./f).*(Vth_f.*Vrh_f)./(Vtr_f.*IR_f));
SH_c=sqrt((2*d/ro./f).*(Vth_c.*Vrh_c)./(Vtr_c.*IR_c));  
          
RVR_t=20*log10(SH_t*P_ref);         
RVR_f=20*log10(SH_f*P_ref);
RVR_c=20*log10(SH_c*P_ref);
 
h=figure('Position',[5 45 1360 635]); hold on
plot(f/1e3,mean(RVR_t),'LineWidth',3,'Color','b');
plot(f/1e3,mean(RVR_f),'LineWidth',3,'Color','r');
plot(f/1e3,mean(RVR_c),'LineWidth',3,'Color','k');
xlabel('Frequency [kHz]','FontSize',15); ylabel('RVR [dB re V/uPa]','FontSize',15);
title(['Received Voltage Response ',nombre_hid_sensibilidad],'FontSize',15); box('on');
legend('RVR (time)','RVR (freq)','RVR (corr)','Location','NorthEastOutside');
set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([RVR_t RVR_f])) max(max([RVR_t RVR_f]))])
saveas(h,[raiz,'\','RVR (utilizando la funcin PLOT) ',nombre_hid_sensibilidad],'fig');
