% TFG Calibracin de sensores acsticos - Pablo Gmez Magenti

clear, clc, close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Vtr -> Voltaje emitiendo con t y recibiendo con r 
% Vth -> Voltaje emitiendo con t y recibiendo con h 
% Vrh -> Voltaje emitiendo con r y recibiendo con h 
% Vrt -> Voltaje emitiendo con r y recibiendo con t 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 

% PISCINA PUERTO:
% raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad9 10.8.2016 (Sensibilidad SX60FR)(PUERTO)(T. ISSCELES)';
% nombre_hid_sensibilidad='SX60FR (T. ISSCELES)(PUERTO)'; 
% OK. dist_utilizada=1m

% raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad10 10.8.2016 (Sensibilidad SX60FR)(PUERTO)(T. ESCALENO)';
% nombre_hid_sensibilidad='SX60FR (T. ESCALENO)(PUERTO)'; 
% OK. dist_utilizada=1.05m

raiz='C:\Users\Pablo\OneDrive\Documentos\UPV\GISTSI\4B - Trabajo de fin de grado\Medidas\Reciprocidad\Reciprocidad11 10.8.2016 (Sensibilidad SX60FR)(PUERTO)(DIST. PLANOS)';
nombre_hid_sensibilidad='SX60FR (DIST. PLANOS)(PUERTO)'; 
% OK. dist_utilizada=1.09m

%%

fs=2*1e6;           % frecuencia de muestro en emisin y recepcin [Hz]
d_ini=0;            % distancia real de la carpeta 0cm [m]
t_ini_env=0;        % tiempo inicial de espera, en su caso [s]
prom=5;             % nmero de promedios de cada seal [-]
ciclos=5;           % ciclos a analizar de cada seal [-]
encabezado=31;      % encabezado que de las seales grabadas ('31' en medidas en plataforma PXI)

carp_rec='Conf1';
[ftr,Vtr_t,Vtr_f,Vtr_c,dtr]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,1,encabezado);
[fth,Vth_t,Vth_f,Vth_c,dth]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,2,encabezado);

carp_rec='Conf2';
[fR,VR_t,VR_f,VR_c,dR]=Vp_senos_resta(raiz,carp_rec,fs,d_ini,'inicio',t_ini_env,100,prom,ciclos,1,2,encabezado);

carp_rec='Conf3';
[frh,Vrh_t,Vrh_f,Vrh_c,drh]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,1,encabezado);
[frt,Vrt_t,Vrt_f,Vrt_c,drt]=Vp_senos(raiz,carp_rec,fs,d_ini,'carpeta',t_ini_env,1,prom,ciclos,2,encabezado);

%% Clculo de sensibilidad y representacin:

if and(ftr==fR,fR==frh)==1;
    f=[ftr;ftr;ftr;ftr;ftr];
else 
    disp('Incompatibilidad entre medidas');
end;

d=(dtr+dth+drh+drt)/6
ro=1500;

% dist1 -> Lado RH; 
% dist2 -> Lado TR; 
% dist3 -> Lado TH;

% Variar valores en funcin de la distribucin real (EN METROS)
% % T. ISSCELES
% dist1_real=1;
% dist2_real=1.4;
% dist3_real=1.4;

% % T. ESCALENO
% dist1_real=1.05;
% dist2_real=1.7;
% dist3_real=1.4;

% % DIST. PLANOS
dist1_real=1.09;
dist2_real=1.71;
dist3_real=1.41;


Vrh_t_adapt=(drh/dist1_real)*Vrh_t;
Vrh_f_adapt=(drh/dist1_real)*Vrh_f;
Vrh_c_adapt=(drh/dist1_real)*Vrh_c;

Vtr_t_adapt=(dtr/dist2_real)*Vtr_t;
Vtr_f_adapt=(dtr/dist2_real)*Vtr_f;
Vtr_c_adapt=(dtr/dist2_real)*Vtr_c;

Vth_t_adapt=(dth/dist3_real)*Vth_t;
Vth_f_adapt=(dth/dist3_real)*Vth_f;
Vth_c_adapt=(dth/dist3_real)*Vth_c;


P_ref=1*1e-6;               % Presin de referencia [Pa]
ValorResistencia=1000;      % Marrn-Negro-Rojo-Oro
                
IR_t=VR_t/ValorResistencia;
IR_f=VR_f/ValorResistencia;
IR_c=VR_c/ValorResistencia;

SH_t=sqrt((2*d/ro./f).*(Vth_t_adapt.*Vrh_t_adapt)./(Vtr_t_adapt.*IR_t));
SH_f=sqrt((2*d/ro./f).*(Vth_f_adapt.*Vrh_f_adapt)./(Vtr_f_adapt.*IR_f));
SH_c=sqrt((2*d/ro./f).*(Vth_c_adapt.*Vrh_c_adapt)./(Vtr_c_adapt.*IR_c));  

RVR_t=20*log10(SH_t*P_ref);         
RVR_f=20*log10(SH_f*P_ref);
RVR_c=20*log10(SH_c*P_ref);

h=figure('Position',[5 45 1360 635]); hold on
plot(f/1e3,mean(RVR_t),'LineWidth',3,'Color','b');
plot(f/1e3,mean(RVR_f),'LineWidth',3,'Color','r');
plot(f/1e3,mean(RVR_c),'LineWidth',3,'Color','k');
xlabel('Frequency [kHz]','FontSize',15); ylabel('RVR [dB re V/uPa]','FontSize',15);
title(['Received Voltage Response ',nombre_hid_sensibilidad],'FontSize',15); box('on');
legend('RVR (time)','RVR (freq)','RVR (corr)','Location','NorthEastOutside');
set(gca,'FontSize',15); axis([f(1)/1e3 f(end)/1e3 min(min([RVR_t RVR_f])) max(max([RVR_t RVR_f]))])
saveas(h,[raiz,'\','RVR (utilizando la funcin PLOT) ',nombre_hid_sensibilidad],'fig');
